#ifndef ARRAY3D_CM_H
#define ARRAY3D_CM_H

//------------------------------------------------------------------------
// Serial storing of 3D array in the Cuthill-Mckee ordering
//    n    : index of the serial ordering
// (s,off) : s=i+j+k and an offset
// (i,j,k) : 3d index
//------------------------------------------------------------------------
struct ARRAY3D_CM
{
	//------------------------------------------------------------------------
	// member variables
	//------------------------------------------------------------------------
	int isize, jsize, ksize; // size of 3d array :isize*jsize*ksize
	int     nsize;           // size of 1d array :isize*jsize*ksize
	double* data ;           // data of 1d array
	int*   n_to_ijk; // convert 1d index to 3d
	int*** ijk_to_n; // convert 3d index to 1d
	int* sum_nbeg ;  // the index of data that begins with given sum value
	int* sum_nsize;  // the number of nodes (i,j,k) s.t. i+j+k=sum
	//------------------------------------------------------------------------
	// memory related functions
	//------------------------------------------------------------------------
	ARRAY3D_CM(           );//default constructor
	ARRAY3D_CM(int,int,int);//isize,jsize,ksize
   ~ARRAY3D_CM(           );//destructor
	ARRAY3D_CM(    const ARRAY3D_CM&);//copy constructor
	void operator=(const ARRAY3D_CM&);//copy operator
	void operator=(double           );
	void resize(int,int,int);//resize
	//------------------------------------------------------------------------
	// print
	//------------------------------------------------------------------------
	void print_j(const char* name, int j, int step=1) const;
	void print_k(const char* name, int k, int step=1) const;
};

#endif

