#ifndef Poisson_Symmetric_7Point_H_CM
#define Poisson_Symmetric_7Point_H_CM

#define OUTSIDE -1
#include "library/library.h"
#include "Index3D_CM.h"

//------------------------------------------------------------------------------------
// The PCG routine for the seven point symmetric Poisson discretization
// based on the MAC grid in three dimensions
//------------------------------------------------------------------------------------
struct Poisson_Symmetric_7Point_CM{
	// member variables
	Index3D_CM index3d_cm; static int NUM_THRS;
	VECTOR Aiph; 
    VECTOR Ajph;
    VECTOR Akph;
    VECTOR Adiag;
    VECTOR Mdiag;
	// operations
    void set_size( int isize, int jsize, int ksize );
    void calculate_MILU();
	void projection_sumzero( VECTOR& X );
	double inner_product( const VECTOR&, const VECTOR& );
    void   apply_A   ( const VECTOR&,  VECTOR& )const;
    void   apply_Minv(       VECTOR&                    )const;
    void   PCG       ( const VECTOR& B, 
		                     VECTOR& X, int NUM_THRS_, 
							 bool impose_sum_zero=false, 
							 int    max_it   =2000, 
							 double tolerance=1E-14 );
};


#endif
